<template>
  <GI18nCard
    i18n="d_si.real.title"
    :level="level"
    :card="card"
    :optional="optional"
    :wiki-entry="wikiEntry"
    @deleteElement="$emit('delete')"
  >
    <template #card-title-append>
      <v-spacer />
      <GDropDownMenu
        i18n="form.addElement"
        :available-elements="availableElements"
        icon="add"
        :btn-class="level === 'third' ? 'theme--light' : 'theme--dark'"
        @addElement="addElement"
      />
    </template>
    <v-row dense>
      <GCol cols="12">
        <XmlTextField v-model="value.label" i18n="d_si.real.label" />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.value"
          i18n="d_si.real.value"
          validate="required decimal"
          ns="si"
        />
      </GCol>
      <GCol cols="12" md="6">
        <XmlTextField
          v-model="value.unit"
          i18n="d_si.real.unit"
          validate="required dsiUnit"
          ns="si"
        />
      </GCol>
      <GCol cols="12">
        <XmlTextField
          v-model="value.dateTime"
          i18n="d_si.real.datetime"
          validate="dateTime"
          ns="si"
        />
      </GCol>
      <GCol cols="12">
        <ExpandedUncertainty
          v-if="value.expandedUnc"
          v-model="value.expandedUnc"
          level="third"
          optional
          @delete="deleteExpandedUnc"
        />
      </GCol>
    </v-row>
  </GI18nCard>
</template>

<script>
import { ExpandedUncType } from "@d-ptb/dcc-js";
import XmlTextField from "../App/Form/XML/XmlTextField";
import ExpandedUncertainty from "./ExpandedUncertainty";
import GI18nCard from "~/components/App/Common/GI18nCard";
import GCol from "~/components/App/Common/GCol";
import GDropDownMenu from "~/components/App/Common/GDropDownMenu.vue";
import { insertIf } from "~/assets/util/general";

export default {
  name: "Real",
  components: {
    GDropDownMenu,
    GCol,
    GI18nCard,
    ExpandedUncertainty,
    XmlTextField,
  },
  props: {
    value: Object,
    updateAvailableElements: Function,
    card: Boolean,
    level: String,
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "dsi",
    },
  },
  computed: {
    availableElements() {
      return ["expandedUncertainty"]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`d_si.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [...insertIf(this.value.expandedUnc, "expandedUncertainty")];
    },
  },
  watch: {
    availableElements: {
      handler() {
        if (typeof this.updateAvailableElements === "function")
          this.updateAvailableElements(this.availableElements);
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "expandedUncertainty":
          this.$set(this.value, "expandedUnc", new ExpandedUncType());
          break;
      }
    },
    deleteExpandedUnc() {
      confirm(this.$t("dcc.tables.expandedUncertaintyXMLList.confirmRemove")) &&
        this.$set(this.value, "expandedUnc", undefined);
    },
  },
};
</script>
